Index: boot/freeldr/freeldr/include/reactos.h
===================================================================
--- boot/freeldr/freeldr/include/reactos.h	(revision 21808)
+++ boot/freeldr/freeldr/include/reactos.h	(working copy)
@@ -49,8 +49,7 @@
 // Loader Functions And Definitions
 //
 ///////////////////////////////////////////////////////////////////////////////////////
- 
-extern LOADER_PARAMETER_BLOCK LoaderBlock; /* Multiboot info structure passed to kernel */
+extern ROS_LOADER_PARAMETER_BLOCK LoaderBlock; /* Multiboot info structure passed to kernel */
 extern char					reactos_kernel_cmdline[255];	// Command line passed to kernel
 extern LOADER_MODULE		reactos_modules[64];		// Array to hold boot module info loaded for the kernel
 extern char					reactos_module_strings[64][256];	// Array to hold module names
@@ -65,6 +64,6 @@
 ULONG_PTR STDCALL FrLdrLoadModule(FILE *ModuleImage, LPCSTR ModuleName, PULONG ModuleSize);
 BOOL STDCALL FrLdrCloseModule(ULONG_PTR ModuleBase, ULONG dwModuleSize);
 VOID STDCALL FrLdrStartup(ULONG Magic);
-typedef VOID (FASTCALL *ASMCODE)(ULONG Magic, PLOADER_PARAMETER_BLOCK LoaderBlock);
+typedef VOID (FASTCALL *ASMCODE)(ULONG Magic, PROS_LOADER_PARAMETER_BLOCK LoaderBlock);
 
 #endif // defined __REACTOS_H
Index: boot/bootdata/txtsetup.sif
===================================================================
--- boot/bootdata/txtsetup.sif	(revision 21808)
+++ boot/bootdata/txtsetup.sif	(working copy)
@@ -37,8 +37,8 @@
 
 [SetupData]
 DefaultPath = \ReactOS
-OsLoadOptions = "/NOGUIBOOT /NODEBUG"
-;OsLoadOptions = "/NOGUIBOOT /DEBUGPORT=COM1 /BAUDRATE=19200 /IRQ=4"
+;OsLoadOptions = "/NOGUIBOOT /NODEBUG"
+OsLoadOptions = "/NOGUIBOOT /DEBUGPORT=COM1 /BREAK"
 ;OsLoadOptions = "/NOGUIBOOT /DEBUGPORT=SCREEN"
 ;OsLoadOptions = "/NOGUIBOOT /DEBUGPORT=BOCHS"
 
Index: hal/hal/hal.c
===================================================================
--- hal/hal/hal.c	(revision 21808)
+++ hal/hal/hal.c	(working copy)
@@ -14,6 +14,8 @@
 #include <ntddk.h>
 #include <ndk/halfuncs.h>
 #include <ndk/kdfuncs.h>
+#include <rosldr.h>
+#include <internal/kd.h>
 
 #define NDEBUG
 #include <debug.h>
@@ -333,7 +335,7 @@
 NTAPI
 HalInitSystem(
   ULONG BootPhase,
-  PLOADER_PARAMETER_BLOCK LoaderBlock)
+  PROS_LOADER_PARAMETER_BLOCK LoaderBlock)
 {
   UNIMPLEMENTED;
 
@@ -344,7 +346,7 @@
 VOID
 NTAPI
 HalInitializeProcessor(ULONG ProcessorNumber,
-                       PLOADER_PARAMETER_BLOCK LoaderBlock)
+                       PROS_LOADER_PARAMETER_BLOCK LoaderBlock)
 {
   UNIMPLEMENTED;
 }
@@ -558,7 +560,7 @@
 VOID
 NTAPI
 IoAssignDriveLetters(
-  PLOADER_PARAMETER_BLOCK LoaderBlock,
+  PROS_LOADER_PARAMETER_BLOCK LoaderBlock,
   PSTRING NtDeviceName,
   PUCHAR NtSystemPath,
   PSTRING NtSystemPathString)
Index: hal/halx86/xbox/display_xbox.c
===================================================================
--- hal/halx86/xbox/display_xbox.c	(revision 21808)
+++ hal/halx86/xbox/display_xbox.c	(working copy)
@@ -284,7 +284,7 @@
 }
 
 VOID FASTCALL
-HalInitializeDisplay (PLOADER_PARAMETER_BLOCK LoaderBlock)
+HalInitializeDisplay (PROS_LOADER_PARAMETER_BLOCK LoaderBlock)
 /*
  * FUNCTION: Initalize the display
  * ARGUMENTS:
Index: hal/halx86/xbox/halinit_xbox.c
===================================================================
--- hal/halx86/xbox/halinit_xbox.c	(revision 21808)
+++ hal/halx86/xbox/halinit_xbox.c	(working copy)
@@ -19,7 +19,7 @@
 /* FUNCTIONS ***************************************************************/
 
 VOID
-HalpInitPhase0(PLOADER_PARAMETER_BLOCK LoaderBlock)
+HalpInitPhase0(PROS_LOADER_PARAMETER_BLOCK LoaderBlock)
 {
   HalpHooks.InitPciBus = HalpXboxInitPciBus;
 
Index: hal/halx86/include/mps.h
===================================================================
--- hal/halx86/include/mps.h	(revision 21808)
+++ hal/halx86/include/mps.h	(working copy)
@@ -9,6 +9,25 @@
 
 #define IRQL2TPR(irql)	    ((irql) >= IPI_LEVEL ? IPI_VECTOR : ((irql) >= PROFILE_LEVEL ? LOCAL_TIMER_VECTOR : ((irql) > DISPATCH_LEVEL ? IRQL2VECTOR(irql) : 0)))
 
+typedef struct _KIRQ_TRAPFRAME
+{
+   ULONG Magic;
+   ULONG Gs;
+   ULONG Fs;
+   ULONG Es;
+   ULONG Ds;
+   ULONG Eax;
+   ULONG Ecx;
+   ULONG Edx;
+   ULONG Ebx;
+   ULONG Esp;
+   ULONG Ebp;
+   ULONG Esi;
+   ULONG Edi;
+   ULONG Eip;
+   ULONG Cs;
+   ULONG Eflags;
+} KIRQ_TRAPFRAME, *PKIRQ_TRAPFRAME;
 
 #if 0
 /* This values are defined in halirql.h */
Index: hal/halx86/include/hal.h
===================================================================
--- hal/halx86/include/hal.h	(revision 21808)
+++ hal/halx86/include/hal.h	(working copy)
@@ -14,12 +14,11 @@
 /* IFS/DDK/NDK Headers */
 #include <ntifs.h>
 #include <ntddk.h>
-#include <ndk/ntndk.h>
+#include <arc/arc.h>
+#include <iotypes.h>
+#include <kefuncs.h>
+#include <rosldr.h>
 
-/* Internal Kernel Headers */
-#include <internal/mm.h>
-#include <internal/ke.h>
-
 #define KPCR_BASE 0xFF000000 // HACK!
 
 /* Internal HAL Headers */
Index: hal/halx86/include/halp.h
===================================================================
--- hal/halx86/include/halp.h	(revision 21808)
+++ hal/halx86/include/halp.h	(working copy)
@@ -8,9 +8,18 @@
 #define HAL_APC_REQUEST	    0
 #define HAL_DPC_REQUEST	    1
 
+//
+// Kernel Debugger Port Definition
+//
+typedef struct _KD_PORT_INFORMATION
+{
+    ULONG ComPort;
+    ULONG BaudRate;
+    ULONG BaseAddress;
+} KD_PORT_INFORMATION, *PKD_PORT_INFORMATION;
+
 /* display.c */
-struct _LOADER_PARAMETER_BLOCK;
-VOID FASTCALL HalInitializeDisplay (struct _LOADER_PARAMETER_BLOCK *LoaderBlock);
+VOID FASTCALL HalInitializeDisplay (struct _ROS_LOADER_PARAMETER_BLOCK *LoaderBlock);
 VOID FASTCALL HalClearDisplay (UCHAR CharAttribute);
 
 /* adapter.c */
@@ -38,7 +47,7 @@
 PVOID HalpMapPhysMemory(ULONG PhysAddr, ULONG Size);
 
 /* Non-generic initialization */
-VOID HalpInitPhase0 (PLOADER_PARAMETER_BLOCK LoaderBlock);
+VOID HalpInitPhase0 (PROS_LOADER_PARAMETER_BLOCK LoaderBlock);
 
 /* sysinfo.c */
 NTSTATUS STDCALL
Index: hal/halx86/up/halinit_up.c
===================================================================
--- hal/halx86/up/halinit_up.c	(revision 21808)
+++ hal/halx86/up/halinit_up.c	(working copy)
@@ -18,7 +18,7 @@
 /* FUNCTIONS ***************************************************************/
 
 VOID
-HalpInitPhase0(PLOADER_PARAMETER_BLOCK LoaderBlock)
+HalpInitPhase0(PROS_LOADER_PARAMETER_BLOCK LoaderBlock)
 {
   HalpInitPICs();
 
Index: hal/halx86/generic/display.c
===================================================================
--- hal/halx86/generic/display.c	(revision 21808)
+++ hal/halx86/generic/display.c	(working copy)
@@ -571,7 +571,7 @@
 /* PRIVATE FUNCTIONS ********************************************************/
 
 VOID FASTCALL
-HalInitializeDisplay (PLOADER_PARAMETER_BLOCK LoaderBlock)
+HalInitializeDisplay (PROS_LOADER_PARAMETER_BLOCK LoaderBlock)
 /*
  * FUNCTION: Initalize the display
  * ARGUMENTS:
Index: hal/halx86/generic/irql.c
===================================================================
--- hal/halx86/generic/irql.c	(revision 21808)
+++ hal/halx86/generic/irql.c	(working copy)
@@ -67,7 +67,7 @@
  * RETURNS: The current irq level
  */
 {
-  return(KeGetCurrentKPCR()->Irql);
+  return(KeGetPcr()->Irql);
 }
 
 VOID HalpInitPICs(VOID)
@@ -136,7 +136,7 @@
     {
       if (HalpPendingInterruptCount[i] > 0)
 	{
-	   KeGetCurrentKPCR()->Irql = (KIRQL)IRQ_TO_DIRQL(i);
+	   KeGetPcr()->Irql = (KIRQL)IRQ_TO_DIRQL(i);
 
            while (HalpPendingInterruptCount[i] > 0)
 	     {
@@ -146,8 +146,8 @@
 	       HalpPendingInterruptCount[i]--;
 	       KiInterruptDispatch2(i + IRQ_BASE, NewIrql);
 	     }
-	   KeGetCurrentKPCR()->Irql--;
-	   HalpEndSystemInterrupt(KeGetCurrentKPCR()->Irql);
+	   KeGetPcr()->Irql--;
+	   HalpEndSystemInterrupt(KeGetPcr()->Irql);
 	}
     }
 
@@ -158,22 +158,22 @@
 {
   if (NewIrql >= PROFILE_LEVEL)
     {
-      KeGetCurrentKPCR()->Irql = NewIrql;
+      KeGetPcr()->Irql = NewIrql;
       return;
     }
   HalpExecuteIrqs(NewIrql);
   if (NewIrql >= DISPATCH_LEVEL)
     {
-      KeGetCurrentKPCR()->Irql = NewIrql;
+      KeGetPcr()->Irql = NewIrql;
       return;
     }
-  KeGetCurrentKPCR()->Irql = DISPATCH_LEVEL;
-  if (((PKIPCR)KeGetCurrentKPCR())->HalReserved[HAL_DPC_REQUEST])
+  KeGetPcr()->Irql = DISPATCH_LEVEL;
+  if (((PKIPCR)KeGetPcr())->HalReserved[HAL_DPC_REQUEST])
     {
-      ((PKIPCR)KeGetCurrentKPCR())->HalReserved[HAL_DPC_REQUEST] = FALSE;
+      ((PKIPCR)KeGetPcr())->HalReserved[HAL_DPC_REQUEST] = FALSE;
       KiDispatchInterrupt();
     }
-  KeGetCurrentKPCR()->Irql = APC_LEVEL;
+  KeGetPcr()->Irql = APC_LEVEL;
   if (NewIrql == APC_LEVEL)
     {
       return;
@@ -183,7 +183,7 @@
     {
       KiDeliverApc(KernelMode, NULL, NULL);
     }
-  KeGetCurrentKPCR()->Irql = PASSIVE_LEVEL;
+  KeGetPcr()->Irql = PASSIVE_LEVEL;
 }
 
 /**********************************************************************
@@ -207,10 +207,10 @@
 {
   DPRINT("KfLowerIrql(NewIrql %d)\n", NewIrql);
   
-  if (NewIrql > KeGetCurrentKPCR()->Irql)
+  if (NewIrql > KeGetPcr()->Irql)
     {
       DbgPrint ("(%s:%d) NewIrql %x CurrentIrql %x\n",
-		__FILE__, __LINE__, NewIrql, KeGetCurrentKPCR()->Irql);
+		__FILE__, __LINE__, NewIrql, KeGetPcr()->Irql);
       KEBUGCHECK(0);
       for(;;);
     }
@@ -266,16 +266,16 @@
   
   DPRINT("KfRaiseIrql(NewIrql %d)\n", NewIrql);
   
-  if (NewIrql < KeGetCurrentKPCR()->Irql)
+  if (NewIrql < KeGetPcr()->Irql)
     {
       DbgPrint ("%s:%d CurrentIrql %x NewIrql %x\n",
-		__FILE__,__LINE__,KeGetCurrentKPCR()->Irql,NewIrql);
+		__FILE__,__LINE__,KeGetPcr()->Irql,NewIrql);
       KEBUGCHECK (0);
       for(;;);
     }
   
-  OldIrql = KeGetCurrentKPCR()->Irql;
-  KeGetCurrentKPCR()->Irql = NewIrql;
+  OldIrql = KeGetPcr()->Irql;
+  KeGetPcr()->Irql = NewIrql;
   return OldIrql;
 }
 
@@ -380,13 +380,13 @@
      WRITE_PORT_UCHAR((PUCHAR)0xa0,0x20);
   }
   
-  if (KeGetCurrentKPCR()->Irql >= Irql)
+  if (KeGetPcr()->Irql >= Irql)
     {
       HalpPendingInterruptCount[irq]++;
       return(FALSE);
     }
-  *OldIrql = KeGetCurrentKPCR()->Irql;
-  KeGetCurrentKPCR()->Irql = Irql;
+  *OldIrql = KeGetPcr()->Irql;
+  KeGetPcr()->Irql = Irql;
 
   return(TRUE);
 }
@@ -461,11 +461,11 @@
   switch (Request)
   {
     case APC_LEVEL:
-      ((PKIPCR)KeGetCurrentKPCR())->HalReserved[HAL_APC_REQUEST] = TRUE;
+      ((PKIPCR)KeGetPcr())->HalReserved[HAL_APC_REQUEST] = TRUE;
       break;
 
     case DISPATCH_LEVEL:
-      ((PKIPCR)KeGetCurrentKPCR())->HalReserved[HAL_DPC_REQUEST] = TRUE;
+      ((PKIPCR)KeGetPcr())->HalReserved[HAL_DPC_REQUEST] = TRUE;
       break;
       
     default:
Index: hal/halx86/generic/timer.c
===================================================================
--- hal/halx86/generic/timer.c	(revision 21808)
+++ hal/halx86/generic/timer.c	(working copy)
@@ -125,9 +125,9 @@
 STDCALL
 KeStallExecutionProcessor(ULONG Microseconds)
 {
-   PKIPCR Pcr = (PKIPCR)KeGetCurrentKPCR();
+   PKIPCR Pcr = (PKIPCR)KeGetPcr();
 
-   if (Pcr->PrcbData.FeatureBits & X86_FEATURE_TSC)
+   if (Pcr->PrcbData.FeatureBits & KF_RDTSC)
    {
       LARGE_INTEGER EndCount, CurrentCount;
       Ki386RdTSC(EndCount);
@@ -201,14 +201,14 @@
     }
 
   UdelayCalibrated = TRUE;
-  Pcr = (PKIPCR)KeGetCurrentKPCR();
+  Pcr = (PKIPCR)KeGetPcr();
 
   /* Initialise timer interrupt with MILLISEC ms interval        */
   WRITE_PORT_UCHAR((PUCHAR) TMR_CTRL, TMR_SC0 | TMR_BOTH | TMR_MD2);  /* binary, mode 2, LSB/MSB, ch 0 */
   WRITE_PORT_UCHAR((PUCHAR) TMR_CNT0, LATCH & 0xff); /* LSB */
   WRITE_PORT_UCHAR((PUCHAR) TMR_CNT0, LATCH >> 8); /* MSB */
 
-  if (Pcr->PrcbData.FeatureBits & X86_FEATURE_TSC)
+  if (Pcr->PrcbData.FeatureBits & KF_RDTSC)
   {
       
      WaitFor8254Wraparound();
@@ -325,9 +325,9 @@
   Ki386SaveFlags(Flags);
   Ki386DisableInterrupts();
 
-  Pcr = (PKIPCR)KeGetCurrentKPCR();
+  Pcr = (PKIPCR)KeGetPcr();
 
-  if (Pcr->PrcbData.FeatureBits & X86_FEATURE_TSC)
+  if (Pcr->PrcbData.FeatureBits & KF_RDTSC)
   {
      Ki386RestoreFlags(Flags);
      if (NULL != PerformanceFreq)
Index: hal/halx86/generic/spinlock.c
===================================================================
--- hal/halx86/generic/spinlock.c	(revision 21808)
+++ hal/halx86/generic/spinlock.c	(working copy)
@@ -91,7 +91,7 @@
  */
 KIRQL
 FASTCALL
-KeAcquireQueuedSpinLockRaiseToSynch(IN PKLOCK_QUEUE_HANDLE LockHandle)
+KeAcquireQueuedSpinLockRaiseToSynch(IN KSPIN_LOCK_QUEUE_NUMBER LockNumber)
 {
     /* Simply raise to dispatch */
     return KfRaiseIrql(DISPATCH_LEVEL);
Index: hal/halx86/generic/halinit.c
===================================================================
--- hal/halx86/generic/halinit.c	(revision 21808)
+++ hal/halx86/generic/halinit.c	(working copy)
@@ -33,17 +33,17 @@
 
 BOOLEAN STDCALL
 HalInitSystem (ULONG BootPhase,
-               PLOADER_PARAMETER_BLOCK LoaderBlock)
+               PROS_LOADER_PARAMETER_BLOCK LoaderBlock)
 {
   if (BootPhase == 0)
     {
       RtlZeroMemory(&HalpHooks, sizeof(HALP_HOOKS));
-      HalpInitPhase0(LoaderBlock);      
+      HalpInitPhase0((PROS_LOADER_PARAMETER_BLOCK)LoaderBlock);      
     }
   else if (BootPhase == 1)
     {
       /* Initialize display and make the screen black */
-      HalInitializeDisplay (LoaderBlock);
+      HalInitializeDisplay ((PROS_LOADER_PARAMETER_BLOCK)LoaderBlock);
       HalpInitBusHandlers();
       HalpInitDma();
 
Index: hal/halx86/mp/halinit_mp.c
===================================================================
--- hal/halx86/mp/halinit_mp.c	(revision 21808)
+++ hal/halx86/mp/halinit_mp.c	(working copy)
@@ -22,7 +22,7 @@
 
 /***************************************************************************/
 VOID
-HalpInitPhase0(PLOADER_PARAMETER_BLOCK LoaderBlock)
+HalpInitPhase0(PROS_LOADER_PARAMETER_BLOCK LoaderBlock)
 
 {
    static BOOLEAN MPSInitialized = FALSE;
Index: hal/halx86/mp/mpsirql.c
===================================================================
--- hal/halx86/mp/mpsirql.c	(revision 21808)
+++ hal/halx86/mp/mpsirql.c	(working copy)
@@ -39,7 +39,7 @@
       DPRINT1 ("CurrentIrql %x\n", irql);
       KEBUGCHECK (0);
     }
-  if (Flags & X86_EFLAGS_IF)
+  if (Flags & EFLAGS_INTERRUPT_MASK)
     {
       Ki386EnableInterrupts();
     }
@@ -62,7 +62,7 @@
   Ki386SaveFlags(Flags);
   Ki386DisableInterrupts();
   Ki386WriteFsByte(FIELD_OFFSET(KPCR, Irql), NewIrql);
-  if (Flags & X86_EFLAGS_IF)
+  if (Flags & EFLAGS_INTERRUPT_MASK)
     {
       Ki386EnableInterrupts();
     }
@@ -90,7 +90,7 @@
           Ki386WriteFsByte(FIELD_OFFSET(KIPCR, HalReserved[HAL_DPC_REQUEST]), 0);
           Ki386EnableInterrupts();
           KiDispatchInterrupt();
-          if (!(Flags & X86_EFLAGS_IF))
+          if (!(Flags & EFLAGS_INTERRUPT_MASK))
             {
               Ki386DisableInterrupts();
             }
@@ -106,7 +106,7 @@
     {
       Ki386EnableInterrupts();
       KiDeliverApc(KernelMode, NULL, NULL);
-      if (!(Flags & X86_EFLAGS_IF))
+      if (!(Flags & EFLAGS_INTERRUPT_MASK))
         {
           Ki386DisableInterrupts();
         }
@@ -207,7 +207,7 @@
       APICWrite (APIC_TPR, IRQL2TPR(NewIrql) & APIC_TPR_PRI);
     }
   KeSetCurrentIrql (NewIrql);
-  if (Flags & X86_EFLAGS_IF)
+  if (Flags & EFLAGS_INTERRUPT_MASK)
     {
       Ki386EnableInterrupts();
     }
@@ -305,7 +305,7 @@
   }
 
   Ki386SaveFlags(Flags);
-  if (Flags & X86_EFLAGS_IF)
+  if (Flags & EFLAGS_INTERRUPT_MASK)
   {
      DPRINT1("HalBeginSystemInterrupt was called with interrupt's enabled\n");
      KEBUGCHECK(0);
@@ -327,7 +327,7 @@
   ULONG Flags;
   Ki386SaveFlags(Flags);
 
-  if (Flags & X86_EFLAGS_IF)
+  if (Flags & EFLAGS_INTERRUPT_MASK)
   {
      DPRINT1("HalEndSystemInterrupt was called with interrupt's enabled\n");
      KEBUGCHECK(0);
Index: hal/halx86/mp/apic.c
===================================================================
--- hal/halx86/mp/apic.c	(revision 21808)
+++ hal/halx86/mp/apic.c	(working copy)
@@ -28,9 +28,10 @@
 /* INCLUDE ***********************************************************************/
 
 #include <hal.h>
+#include <halfuncs.h> /* Not in PCH because only used for MP HAL */
+#include <rtlfuncs.h> /* Not in PCH because only used for MP HAL */
 #define NDEBUG
 #include <debug.h>
-#include <internal/ntoskrnl.h>
 
 /* GLOBALS ***********************************************************************/
 
@@ -809,7 +810,7 @@
    CPU = ThisCPU();
    if ((Count[CPU] % 100) == 0)
    {
-     DbgPrint("(%s:%d) MpsTimerHandler on CPU%d, irql = %d, epi = %x, KPCR = %x\n", __FILE__, __LINE__, CPU, oldIrql,Trapframe->Eip, KeGetCurrentKPCR());
+     DbgPrint("(%s:%d) MpsTimerHandler on CPU%d, irql = %d, epi = %x, KPCR = %x\n", __FILE__, __LINE__, CPU, oldIrql,Trapframe->Eip, KeGetPcr());
    }
    Count[CPU]++;
 #endif
@@ -862,7 +863,7 @@
 
    APICSetupLVTT(1000000000);
 
-   TSCPresent = ((PKIPCR)KeGetCurrentKPCR())->PrcbData.FeatureBits & X86_FEATURE_TSC ? TRUE : FALSE;
+   TSCPresent = ((PKIPCR)KeGetPcr())->PrcbData.FeatureBits & KF_RDTSC ? TRUE : FALSE;
 
    /*
     * The timer chip counts down to zero. Let's wait
@@ -891,7 +892,7 @@
       DPRINT("CPU clock speed is %ld.%04ld MHz.\n",
 	     CPUMap[CPU].CoreSpeed/1000000,
 	     CPUMap[CPU].CoreSpeed%1000000);
-      ((PKIPCR)KeGetCurrentKPCR())->PrcbData.MHz = CPUMap[CPU].CoreSpeed/1000000;
+      ((PKIPCR)KeGetPcr())->PrcbData.MHz = CPUMap[CPU].CoreSpeed/1000000;
    }
 
    CPUMap[CPU].BusSpeed = (HZ * (long)(tt1 - tt2) * APIC_DIVISOR);
@@ -919,7 +920,7 @@
   Access.SystemSegmentFlag = 0;
   Access.SegmentType = I386_INTERRUPT_GATE;
   
-  idt = (KIDTENTRY*)((ULONG)KeGetCurrentKPCR()->IDT + index * sizeof(KIDTENTRY));
+  idt = (KIDTENTRY*)((ULONG)KeGetPcr()->IDT + index * sizeof(KIDTENTRY));
   idt->Offset = address & 0xffff;
   idt->Selector = KGDT_R0_CODE;
   idt->Access = Access.Value;
@@ -1037,11 +1038,11 @@
    /* Write the location of the AP stack */
    Common->Stack = (ULONG)Stack;
    /* Write the page directory page */
-   Ke386GetPageTableDirectory(Common->PageDirectory);
+   Common->PageDirectory = __readcr3();
    /* Write the kernel entry point */
    Common->NtProcessStartup = (ULONG_PTR)RtlImageNtHeader((PVOID)KernelBase)->OptionalHeader.AddressOfEntryPoint + KernelBase;
    /* Write the state of the mae mode */
-   Common->PaeModeEnabled = Ke386GetCr4() & X86_CR4_PAE ? 1 : 0;
+   Common->PaeModeEnabled = __readcr4() & CR4_PAE ? 1 : 0;
 
    DPRINT1("%x %x %x %x\n", Common->Stack, Common->PageDirectory, Common->NtProcessStartup, Common->PaeModeEnabled);
 
Index: lib/epsapi/enum/drivers.c
===================================================================
--- lib/epsapi/enum/drivers.c	(revision 21808)
+++ lib/epsapi/enum/drivers.c	(working copy)
@@ -28,7 +28,7 @@
 PsaEnumerateSystemModules(IN PSYSMOD_ENUM_ROUTINE Callback,
                           IN OUT PVOID CallbackContext)
 {
-  PSYSTEM_MODULE_INFORMATION psmModules;
+  PRTL_PROCESS_MODULES psmModules;
   NTSTATUS Status = STATUS_SUCCESS;
 
 #if 0
@@ -65,10 +65,10 @@
 }
 
 NTSTATUS NTAPI
-PsaCaptureSystemModules(OUT PSYSTEM_MODULE_INFORMATION *SystemModules)
+PsaCaptureSystemModules(OUT PRTL_PROCESS_MODULES *SystemModules)
 {
   SIZE_T nSize = 0;
-  PSYSTEM_MODULE_INFORMATION psmModules = NULL;
+  PRTL_PROCESS_MODULES psmModules = NULL;
   NTSTATUS Status;
 
 #if 0
@@ -94,8 +94,8 @@
      minimize memory operations that could be expensive, or fragment the
      pool/heap, we try to determine the buffer size in advance, knowing that
      the number of elements is unlikely to change */
-  nSize = sizeof(SYSTEM_MODULE_INFORMATION) +
-          (nSize * sizeof(SYSTEM_MODULE_INFORMATION));
+  nSize = sizeof(RTL_PROCESS_MODULES) +
+          (nSize * sizeof(RTL_PROCESS_MODULES));
 
   psmModules = NULL;
 
@@ -157,7 +157,7 @@
 }
 
 NTSTATUS NTAPI
-PsaWalkSystemModules(IN PSYSTEM_MODULE_INFORMATION SystemModules,
+PsaWalkSystemModules(IN PRTL_PROCESS_MODULES SystemModules,
                      IN PSYSMOD_ENUM_ROUTINE Callback,
                      IN OUT PVOID CallbackContext)
 {
@@ -165,10 +165,10 @@
   NTSTATUS Status;
 
   /* repeat until all modules have been returned */
-  for(i = 0; i < SystemModules->Count; i++)
+  for(i = 0; i < SystemModules->NumberOfModules; i++)
   {
     /* return current module to the callback */
-    Status = Callback(&(SystemModules->Module[i]), CallbackContext);
+    Status = Callback(&(SystemModules->Modules[i]), CallbackContext);
   
     if(!NT_SUCCESS(Status))
     {
@@ -179,18 +179,18 @@
   return STATUS_SUCCESS;
 }
 
-PSYSTEM_MODULE_INFORMATION_ENTRY FASTCALL
-PsaWalkFirstSystemModule(IN PSYSTEM_MODULE_INFORMATION SystemModules)
+PRTL_PROCESS_MODULE_INFORMATION FASTCALL
+PsaWalkFirstSystemModule(IN PRTL_PROCESS_MODULES SystemModules)
 { 
-  return &(SystemModules->Module[0]);
+  return &(SystemModules->Modules[0]);
 }
 
-PSYSTEM_MODULE_INFORMATION_ENTRY FASTCALL
-PsaWalkNextSystemModule(IN PSYSTEM_MODULE_INFORMATION CurrentSystemModule)
+PRTL_PROCESS_MODULE_INFORMATION FASTCALL
+PsaWalkNextSystemModule(IN PRTL_PROCESS_MODULES CurrentSystemModule)
 {
-  return (PSYSTEM_MODULE_INFORMATION_ENTRY)((ULONG_PTR)CurrentSystemModule +
-                                            (FIELD_OFFSET(SYSTEM_MODULE_INFORMATION, Module[1]) -
-                                             FIELD_OFFSET(SYSTEM_MODULE_INFORMATION, Module[0])));
+  return (PRTL_PROCESS_MODULE_INFORMATION)((ULONG_PTR)CurrentSystemModule +
+                                            (FIELD_OFFSET(RTL_PROCESS_MODULES, Modules[1]) -
+                                             FIELD_OFFSET(RTL_PROCESS_MODULES, Modules[0])));
 }
 
 /* EOF */
Index: lib/epsapi/enum/processes.c
===================================================================
--- lib/epsapi/enum/processes.c	(revision 21808)
+++ lib/epsapi/enum/processes.c	(working copy)
@@ -265,7 +265,7 @@
   static SIZE_T nOffsetOfThreads = 0;
 
   /* get the offset of the Threads field */
-  nOffsetOfThreads = FIELD_OFFSET(SYSTEM_PROCESS_INFORMATION, TH);
+  nOffsetOfThreads = sizeof(SYSTEM_PROCESS_INFORMATION);
 
   return (PSYSTEM_THREAD_INFORMATION)((ULONG_PTR)CurrentProcess + nOffsetOfThreads);
 }
@@ -274,8 +274,8 @@
 PsaWalkNextThread(IN PSYSTEM_THREAD_INFORMATION CurrentThread)
 {
   return (PSYSTEM_THREAD_INFORMATION)((ULONG_PTR)CurrentThread +
-                           (FIELD_OFFSET(SYSTEM_PROCESS_INFORMATION, TH[1]) -
-                            FIELD_OFFSET(SYSTEM_PROCESS_INFORMATION, TH[0])));
+                           ((sizeof(SYSTEM_PROCESS_INFORMATION) + sizeof(SYSTEM_THREAD_INFORMATION)) -
+                            sizeof(SYSTEM_PROCESS_INFORMATION)));
 }
 
 /* EOF */
Index: lib/epsapi/enum/modules.c
===================================================================
--- lib/epsapi/enum/modules.c	(revision 21808)
+++ lib/epsapi/enum/modules.c	(working copy)
@@ -50,7 +50,7 @@
  
       while(Current != ListHead)
       {
-        PLDR_DATA_TABLE_ENTRY LoaderModule = CONTAINING_RECORD(Current, LDR_DATA_TABLE_ENTRY, InLoadOrderModuleList);
+        PLDR_DATA_TABLE_ENTRY LoaderModule = CONTAINING_RECORD(Current, LDR_DATA_TABLE_ENTRY, InLoadOrderLinks);
    
         /* return the current module to the callback */
         Status = Callback(ProcessHandle, LoaderModule, CallbackContext);
@@ -60,7 +60,7 @@
           goto Failure;
         }
     
-        Current = LoaderModule->InLoadOrderModuleList.Flink;
+        Current = LoaderModule->InLoadOrderLinks.Flink;
       }
 #if 0
     }
@@ -117,7 +117,7 @@
     {
       /* read the current module */
       Status = NtReadVirtualMemory(ProcessHandle,
-                                   CONTAINING_RECORD(Current, LDR_DATA_TABLE_ENTRY, InLoadOrderModuleList),
+                                   CONTAINING_RECORD(Current, LDR_DATA_TABLE_ENTRY, InLoadOrderLinks),
                                    &LoaderModule,
                                    sizeof(LoaderModule),
                                    NULL);
@@ -137,7 +137,7 @@
       }
     
       /* address of the next module in the list */
-      Current = LoaderModule.InLoadOrderModuleList.Flink;
+      Current = LoaderModule.InLoadOrderLinks.Flink;
     }
   }
 
Index: lib/rtl/sd.c
===================================================================
--- lib/rtl/sd.c	(revision 21808)
+++ lib/rtl/sd.c	(working copy)
@@ -800,9 +800,6 @@
         return STATUS_BAD_DESCRIPTOR_FORMAT;
     }
 
-    ASSERT(FIELD_OFFSET(SECURITY_DESCRIPTOR, Owner) ==
-           FIELD_OFFSET(SECURITY_DESCRIPTOR_RELATIVE, Owner));
-
 #ifdef _WIN64
 
     RtlpQuerySecurityDescriptor((PISECURITY_DESCRIPTOR)pRelSD,
@@ -915,8 +912,6 @@
                                         &pSacl,
                                         &pDacl);
 
-    ASSERT(sizeof(SECURITY_DESCRIPTOR) == sizeof(SECURITY_DESCRIPTOR_RELATIVE));
-
     /* clear the self-relative flag and simply convert the offsets to pointers */
     pAbsSD->Control &= ~SE_SELF_RELATIVE;
     pAbsSD->Owner = pOwner;
Index: lib/rtl/crc32.c
===================================================================
--- lib/rtl/crc32.c	(revision 21808)
+++ lib/rtl/crc32.c	(working copy)
@@ -85,7 +85,7 @@
  * @implemented
  */
 ULONG NTAPI
-RtlComputeCrc32 (IN ULONG Initial,
+RtlComputeCrc32 (IN UINT Initial,
 		 IN PUCHAR Data,
 		 IN ULONG Length)
 {
Index: lib/rtl/image.c
===================================================================
--- lib/rtl/image.c	(revision 21808)
+++ lib/rtl/image.c	(working copy)
@@ -45,12 +45,10 @@
  */
 PVOID
 NTAPI
-RtlImageDirectoryEntryToData (
-	PVOID	BaseAddress,
-	BOOLEAN	bMappedAsImage,
-	ULONG	Directory,
-	PULONG	Size
-	)
+RtlImageDirectoryEntryToData(PVOID BaseAddress,
+                             BOOLEAN MappedAsImage,
+                             USHORT Directory,
+                             PULONG Size)
 {
 	PIMAGE_NT_HEADERS NtHeader;
 	ULONG Va;
@@ -59,7 +57,7 @@
 	if ((ULONG_PTR)BaseAddress & 1)
 	{
 		BaseAddress = (PVOID)((ULONG_PTR)BaseAddress & ~1);
-		bMappedAsImage = FALSE;
+		MappedAsImage = FALSE;
         }
 
 
@@ -76,7 +74,7 @@
 
 	*Size = NtHeader->OptionalHeader.DataDirectory[Directory].Size;
 
-	if (bMappedAsImage || Va < NtHeader->OptionalHeader.SizeOfHeaders)
+	if (MappedAsImage || Va < NtHeader->OptionalHeader.SizeOfHeaders)
 		return (PVOID)((ULONG_PTR)BaseAddress + Va);
 
 	/* image mapped as ordinary file, we must find raw pointer */
Index: lib/rtl/unicode.c
===================================================================
--- lib/rtl/unicode.c	(revision 21808)
+++ lib/rtl/unicode.c	(working copy)
@@ -2185,7 +2185,7 @@
  */
 NTSTATUS NTAPI
 RtlValidateUnicodeString(IN ULONG Flags,
-                         IN PUNICODE_STRING UnicodeString)
+                         IN PCUNICODE_STRING UnicodeString)
 {
   /* currently no flags are supported! */
   ASSERT(Flags == 0);
